/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */


/*
 * Linux Bandwidth Manager v0.1
 * by Bertrand Goareguer <bertrand.goareguer@gmail.com>
 *
 * to compile : $ gcc -o lbm `pkg-config --cflags --libs gtk+-2.0` -Wall lbm_ui.c lbm.c
 * to start : sudo ./lbm --input-interface eth0
 *
 * TODO:
 *	- 
 */


#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>

#include "lbm.h"
#include "configuration_file_creation.h"

//
//write the configuration file
//
void write_configuration_file(char config_file [256], const gchar * input_interface_string, const gchar * max_download_bitrate_string)
{
	FILE * fout = NULL;

	printf("config_file = %s\n",config_file);

	fout=fopen(config_file,"w");
	if(fout==NULL)
		return;

	fputs(input_interface_string, fout);
	fputs(max_download_bitrate_string, fout);
	fclose(fout);
}


//
//display a dialog for asking the user the configuration information
//
void create_configuration_file (char config_file[256])
{
	GtkWidget *my_dialog, *input_interface_label, *max_download_bitrate_label, *input_interface_entry, *max_download_bitrate_entry;

	gint response;

	my_dialog = gtk_dialog_new_with_buttons("my_dialog",
						(GtkWindow*)window,
						GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
						GTK_STOCK_OK,
						GTK_RESPONSE_ACCEPT,
						GTK_STOCK_CANCEL,
						GTK_RESPONSE_REJECT,
						NULL);

	input_interface_label = gtk_label_new ("Input interface : ");
	max_download_bitrate_label = gtk_label_new ("Max download bitrate (kbps) : ");
	input_interface_entry = gtk_entry_new();
	max_download_bitrate_entry = gtk_entry_new();


	
	gtk_container_add (GTK_CONTAINER ((GTK_DIALOG(my_dialog))->vbox), input_interface_label);
	gtk_container_add (GTK_CONTAINER ((GTK_DIALOG(my_dialog))->vbox), input_interface_entry);
	gtk_container_add (GTK_CONTAINER ((GTK_DIALOG(my_dialog))->vbox), max_download_bitrate_label);
	gtk_container_add (GTK_CONTAINER ((GTK_DIALOG(my_dialog))->vbox), max_download_bitrate_entry);

	gtk_widget_show_all (my_dialog);

	response = gtk_dialog_run((GtkDialog*)my_dialog);

	if(response == GTK_RESPONSE_ACCEPT)
	{
		const gchar *input_interface_string;
		const gchar *max_download_bitrate_string;

		input_interface_string = gtk_entry_get_text (GTK_ENTRY (input_interface_entry));
		max_download_bitrate_string = gtk_entry_get_text (GTK_ENTRY (max_download_bitrate_entry));
		
		write_configuration_file(config_file, input_interface_string, max_download_bitrate_string);
	}

	gtk_widget_destroy (my_dialog);

}




