/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */


#define NB_PRIORITY 3
#define MAX_FILTER_HANDLES 1000
#define MAX_CHILDREN_PER_ROOT 1024
//#define MAX_DOWNLOAD_BITRATE 480
#define REFRESH_TIMEOUT 1000
#define DEFAULT_PRIORITY_ORDER 1

#define HOME "/root"
#define CONFIG_FILE ".lbm/lbm.conf"


// data structures
typedef struct connection_info * connection_info_p;
typedef struct connection_info
{
	char proto[8];
	char remote_addr[16];
	unsigned int remote_port;
	unsigned int local_port;
	char state[32];
	unsigned int pid;
	char process_name[64];
	unsigned int priority; // 0=high priority, 1=medium priority, 2=low priority, etc...
	char path[8]; // path in the unsorted tree store
	int rate; // -1 means rate limiting is off, otherwise the rate is in kbps
	unsigned int filter_handle;
//	char manual_priority; // 0=the priority has to be automatically guessed, 1=the priority is given by the user
	connection_info_p next;
}connection_info_t;



// global variables
// these data need to be global in order to clean everything up on SIGINT
char input_interface[8];
connection_info_p connections_list;


GtkWidget *window;
GtkWidget *dialog;


int max_download_bitrate; // we use a signed integer here because the atoi function works poorly with unsigned int variables


// function prototypes
int lbm_main(int argc, char ** argv);
void sigint_handler(int a);
void lbm_refresh_timeout (gpointer data);
connection_info_p find_connection_from_path(connection_info_p connections_list,char path[8]);
void print_connection(connection_info_p connection);
void reload_automatic_rules(void);

void add_filter(connection_info_p connection);
void remove_filter(connection_info_p connection);


